diff options
author | Klement Sekera <ksekera@cisco.com> | 2017-08-11 10:06:15 +0200 |
---|---|---|
committer | Dave Wallace <dwallacelf@gmail.com> | 2017-08-14 15:21:43 +0000 |
commit | db4e84cf2f8de0909c3483c8cadb25ac72fb3367 (patch) | |
tree | 4a53ac49f39e3c492088e417050b7c1d98760e88 /test/scripts | |
parent | 3214dc382342573c242782849d98c23009960633 (diff) |
make test: properly handle ctrl-c
Change-Id: Iab88886ebc1582626813777ea45ce97fc8e36443
Signed-off-by: Klement Sekera <ksekera@cisco.com>
Diffstat (limited to 'test/scripts')
-rwxr-xr-x | test/scripts/run_in_venv_with_cleanup.sh (renamed from test/scripts/run_with_cleanup.sh) | 17 | ||||
-rwxr-xr-x | test/scripts/setsid_wrapper.sh | 12 |
2 files changed, 27 insertions, 2 deletions
diff --git a/test/scripts/run_with_cleanup.sh b/test/scripts/run_in_venv_with_cleanup.sh index dcaa58b4498..541f584ac45 100755 --- a/test/scripts/run_with_cleanup.sh +++ b/test/scripts/run_in_venv_with_cleanup.sh @@ -17,9 +17,22 @@ atexit() { exit $rv } -trap "atexit" SIGINT SIGTERM +trap "atexit;" SIGINT SIGTERM + +FORCE_FOREGROUND=$1 +shift + +source $1 +shift + +if [[ "${FORCE_FOREGROUND}" == "1" ]] +then + $* +else + $* & + wait +fi -$* rv=$? atexit exit $rv diff --git a/test/scripts/setsid_wrapper.sh b/test/scripts/setsid_wrapper.sh new file mode 100755 index 00000000000..e18b6ad5947 --- /dev/null +++ b/test/scripts/setsid_wrapper.sh @@ -0,0 +1,12 @@ +#!/bin/bash + +if [[ "$1" == "1" ]] +then + setsid scripts/run_in_venv_with_cleanup.sh $* + pid=$! +else + setsid scripts/run_in_venv_with_cleanup.sh $* & + pid=$! + trap "echo setsid_wrapper.sh: got signal, killing child pid ${pid}; kill ${pid}; sleep .1;" SIGINT SIGTERM + wait +fi |